MKSWAP(8)

NAME
mkswap - set up a Linux swap area

SYNOPSIS
mkswap [-c] [-f] [-p PSZ] [-L label] [-U uuid] device [size]

DESCRIPTION
mkswap sets up a Linux swap area on a device or in a file.

The device argument will usually be a disk partition (something like /dev/sdb7) but can also be a file. The Linux kernel does not look at partition Id's, but many installation scripts will assume that partitions of hex type 82 (LINUX_SWAP) are meant to be swap partitions. (Warning: Solaris also uses this type. Be careful not to kill your Solaris partitions.)

The size parameter is superfluous but retained for backwards compatibility. (It specifies the desired size of the swap area in 1024-byte blocks. mkswap will use the entire partition or file if it is omitted. Specifying it is unwise - a typo may destroy your disk.)

The PSZ parameter specifies the page size to use. It is almost always unnecessary (even unwise) to specify it, but certain old libc versions lie about the page size, so it is possible that mkswap gets it wrong. The symptom is that a subsequent swapon fails because no swap signature is found. Typical values for PSZ are 4096 or 8192.

After creating the swap area, you need the swapon command to start using it. Usually swap areas are listed in /etc/fstab so that they can be taken into use at boot time by a swapon -a command in some boot script.

WARNING
The swap header does not touch the first block. A boot loader or disk label can be there, but it is not recommended setup. The recommended setup is to use a separate partition for a Linux swap area.

mkswap like many others mkfs-like utils erases the first block to remove old on-disk filesystems.

mkswap refuses to erase the first block on a device with a disk label (SUN, BSD, ...) or on whole disk (e.g. /dev/sda).

OPTIONS

-c  Check the device (if it is a block device) for bad blocks before creating the swap area. If any are found, the count is printed.

-f  Force - go ahead even if the command is stupid. This allows the creation of a swap area larger than the file or partition it resides on.

    Without this option mkswap will refuse to erase the first block on a device with a partition table or on whole disk (e.g. /dec/sda).

-p PSZ
    Specify the page size to use.

-L label
    Specify a label, to allow swapon by label. (Only for new style swap areas.)

-v0, -v1
    Specify the swap space version. This option is deprecated and -v1 is supported only.

    The kernel has not supported v0 swap space format since 2.5.22. The new version v1 is supported since 2.1.117.

-U uuid
    Specify the uuid to use. The default is to generate UUIDs.

NOTES
The maximum useful size of a swap area depends on the architecture and the kernel version. It is roughly 2GiB on i386, PPC, m68k, ARM, 1GiB on sparc, 512MiB on mips, 128GiB on alpha and 3TiB on sparc64. For kernels after 2.3.3 there is no such limitation.

Note that before 2.1.117 the kernel allocated one byte for each page, while it now allocates two bytes, so that taking a swap area of 2 GiB in use might require 2 MiB of kernel memory.

Presently, Linux allows 32 swap areas (this was 8 before Linux 2.4.10). The areas in use can be seen in the file /proc/swaps (since 2.1.25).

mkswap refuses areas smaller than 10 pages.

If you don't know the page size that your machine uses, you may be able to look it up with "cat /proc/cpuinfo" (or you may not - the contents of this file depend on architecture and kernel version).

To setup a swap file, it is necessary to create that file before initializing it with mkswap , e.g. using a command like

    # dd if=/dev/zero of=swapfile bs=1024 count=65536

Note that a swap file must not contain any holes (so, using cp(1) to create the file is not acceptable).

SEE ALSO
fdisk(8), swapon(8)

AVAILABILITY
The mkswap command is part of the util-linux-ng package and is available from ftp://ftp.kernel.org/pub/linux/utils/util-linux-ng/.